import processing.core.*; 
import processing.xml.*; 

import java.awt.*; 
import javax.swing.*; 
import ddf.minim.analysis.*; 
import ddf.minim.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class FFT_Analyzer extends PApplet {

//FFT_Analyzer Ver.1.1    2014.2\u3000\u672d\u5e4c\u5317\u9ad8\u7b49\u5b66\u6821\u5b9a\u6642\u5236\u6559\u8aed\u3000\u9ad8\u6728\u4f38\u96c4\u4f5c\u6210

//******** \u5909\u6570\u7b49\u306e\u5b9a\u7fa9 ********//


  //Library minim\u4f7f\u7528

Minim minim;
AudioInput in;  // \u30aa\u30fc\u30c7\u30a3\u30aa\u5165\u529b\u306e\u5909\u6570
PFont font1;  //PFont\u30aa\u30d6\u30b8\u30a7\u30af\u30c8\u751f\u6210
PFont font2;  //PFont\u30aa\u30d6\u30b8\u30a7\u30af\u30c8\u751f\u6210
PImage img;  //PImage\u30aa\u30d6\u30b8\u30a7\u30af\u30c8\u751f\u6210
FFT fft;  // FFT\u306e\u5909\u6570
int samplerate;  //samplerate
int buffersize;  //buffersize
int sensitivity;  //\u7e26\u8ef8\u306e\u500d\u7387
int frameCounter;  //ENTER\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u30ab\u30a6\u30f3\u30bf\u30fc
int con_frameCounter;  //SPASE\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u30ab\u30a6\u30f3\u30bf\u30fc
int framearate;  //frameRate
int keptTime;  //\u30b9\u30da\u30fc\u30b9\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u30bf\u30a4\u30e0
int presentTime;  //\uff30\uff23\u306e\u30bf\u30a4\u30e0\uff08\u79d2\uff09
boolean bool_saveFrame;  //\u9023\u7d9a\u753b\u50cf\u4fdd\u5b58\u7528\u3001\u30b9\u30da\u30fc\u30b9\u30ad\u30fc\u5bfe\u5fdc
boolean bool_size;  //\u30b5\u30a4\u30ba\u5909\u66f4\u7528\u3001\uff22\u30ad\u30fc\u5bfe\u5fdc
boolean bool_Nkey;  //\u4e00\u6642\u505c\u6b62\u30fb\u89e3\u9664\u7528\u3001\uff2e\u30ad\u30fc\u5bfe\u5fdc
boolean bool_Hamming;  //Hamming\u7a93\u95a2\u6570On,Off\u3001V\u30ad\u30fc\u5bfe\u5fdc
boolean bool_img;  //\u30ad\u30fc\u30dc\u30fc\u30c9\u5272\u5f53\u8aac\u660e\u753b\u50cf\u8868\u793a\u30fb\u975e\u8868\u793a\u7528\u3000I\u30ad\u30fc\u5bfe\u5fdc
String savefileName; //\u4fdd\u5b58\u30d5\u30a1\u30a4\u30eb\u306e\u540d\u524d
String windowName;  //\u7a93\u95a2\u6570\u8868\u793a

//******** \u521d\u671f\u5316\u51e6\u7406 ********//
public void setup()
{
  framearate=30;  //frameRate\u306e\u521d\u671f\u5024\u309230\u306b\u8a2d\u5b9a
  size(1200, 600);
  frameRate(framearate);
  samplerate = 40960;
  buffersize = 4096;  //\uff12\u306e\u7d2f\u4e57\u306b\u3057\u306a\u3051\u308c\u3070\u306a\u3089\u306a\u3044
  sensitivity = 3;
  frameCounter = 1;
  con_frameCounter =1;
  bool_saveFrame = false;
  bool_size = true;
  bool_Nkey = false;
  bool_Hamming = false;
  windowName = "None";
  savefileName = "img";
  bool_img = true;
  minim = new Minim(this);
  in = minim.getLineIn(Minim.STEREO, buffersize, samplerate);
  fft = new FFT(in.bufferSize(), samplerate);
  font1 = createFont("MS Gothic", 10, true); 
  font2 = createFont("MS Gothic", 15, true);
}

//******** \u63cf\u753b\u51e6\u7406 ********//
public void draw()
{
  background(0);  // \u80cc\u666f\u8272\u3092\u9ed2\u306b\u8a2d\u5b9a
  fft.forward(in.mix);   // FFT \u5b9f\u884c

  // \u68d2\u30b0\u30e9\u30d5\u306e\u63cf\u753b
  for (int i = 0; i < 301; i++)
  {
    float x = map(i, 0, 300, 0, width);
    stroke(255);  //\u7dda\u306e\u8272\u3092\u767d\u306b\u8a2d\u5b9a
    strokeWeight(2);  //\u7dda\u306e\u592a\u3055\u3092\uff12\u306b\u8a2d\u5b9a
    line(x, height-35, x, height-35 - fft.getBand(i) * sensitivity * 4);
    strokeWeight(1);  //\u7dda\u306e\u592a\u3055\u3092\uff11\u306b\u8a2d\u5b9a 
    line(x, height-30, x, height-20);   //\u76ee\u76db\u308a\u7dda

    //10\u76ee\u76db\u308a\u3054\u3068\u306b\u592a\u3044\u8d64\u7dda\u3068\u5468\u6ce2\u6570\u5024\u3092\u5165\u308c\u308b
    if (i%10==0) {
      strokeWeight(2);  //\u7dda\u306e\u592a\u3055\u3092\uff12\u306b\u8a2d\u5b9a
      stroke(180, 0, 0);  //\u8d64
      line(x, height-30, x, height-20);
      textFont(font1); 
      fill(255);  //\u6587\u5b57\u306e\u8272\u3092\u767d\u306b\u8a2d\u5b9a
      text(i*10, x, height - 5);
    }
  }
  //\u57fa\u6e96\u306e\u6c34\u5e73\u7dda\u3092\u5f15\u304f
  stroke(180);   // \u7dda\u306e\u8272\u3092\u7070\u8272\u306b\u8a2d\u5b9a
  strokeWeight(2);  //\u7dda\u306e\u592a\u3055\u3092\uff12\u306b\u8a2d\u5b9a
  line(0, height-35, width, height-35);  

  textFont(font1);
  fill(255);
  text("Hz", width-15, height-5);
  textFont(font2);
  fill(255);
  text("sensitivity " + sensitivity, 165, 20);  //\u753b\u9762\u306bsensitivity\u8868\u793a
  text("frameRate " + framearate + "/sec", 15, 20);  //\u753b\u9762\u306bframeRate\u8868\u793a
  text("window function " + windowName, 290, 20);  //\u753b\u9762\u306b\u7a93\u95a2\u6570\u8868\u793a

  //10\u79d2\u7d4c\u904e\u6e2c\u5b9a\u3001\u753b\u50cf\u4fdd\u5b58\u5b9f\u884c 
  presentTime = second();
  if (bool_saveFrame == true) {
    saveFrame("c_" + savefileName + con_frameCounter + ".tif"); 
    con_frameCounter = con_frameCounter + 1;
      if (presentTime - keptTime == 10 || presentTime - keptTime + 60 == 10) {
        bool_saveFrame = false;
      }
    noStroke();  
    fill(255, 0, 0);
    ellipse(550, 15, 12, 12);  //\u753b\u9762\u306b\u8d64\u4e38\u8868\u793a
  }
  
  //\u30ad\u30fc\u30dc\u30fc\u30c9\u5272\u5f53\u8aac\u660e\u753b\u50cf\u8868\u793a
  if(bool_img == true){
    img = loadImage("data/img.jpg");
    image(img,15,15,width-30,height-25 );
    noLoop();
  }
}

//******** \u30ad\u30fc\u306b\u6a5f\u80fd\u5272\u308a\u5f53\u3066 ********//
public void keyPressed() 
{
  //ENTER\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406
  if (key == ENTER && bool_img == false) { 
    save(savefileName + frameCounter + ".tif");
    frameCounter = frameCounter + 1;
  }
  //SPASE\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406    
  if (key == ' ' && bool_Nkey == false && bool_img == false) {
    if (bool_saveFrame == false) {
      bool_saveFrame = true;
      keptTime = presentTime;
    }
    else if (bool_saveFrame ==true) {
      bool_saveFrame = false;
    }
  }
  //\u77e2\u5370\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406   
  if (key == CODED && bool_img == false) {	
    if (keyCode == UP) {
      if (sensitivity < 5) {
        sensitivity = sensitivity + 1 ;
      }
    } 
    else if (keyCode == DOWN) {
      if (sensitivity > 1) { 
        sensitivity = sensitivity - 1;
      }
    }
    else if (keyCode == RIGHT) {
      if (framearate < 60) {
        framearate = framearate + 10 ;
        frameRate(framearate);
      }
    } 
    else if (keyCode == LEFT) {
      if (framearate > 10) { 
        framearate = framearate - 10;
        frameRate(framearate);
      }
    }
  }
  // S\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406 \uff08 Stop\u3001FFT\u505c\u6b62\uff09    
  if (key == 's' && bool_img == false|| key == 'S' && bool_img == false) {
    if(bool_Nkey == false){
      noLoop();
      bool_saveFrame = false;
      bool_Nkey = true;
      textFont(font2); 
      fill(255, 255, 0);    
      text("Stop", 500, 20); 
      //\u8d64\u4e38\u3092\u9ed2\u304f\u5857\u308b
      noStroke();  
      fill(0, 0, 0);
      ellipse(550, 15, 12, 12);
    }
    else if(bool_Nkey == true){
      bool_Nkey = false;
      loop();      
    }
  }
  //F\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406 \uff08\u30b5\u30a4\u30ba\u5909\u66f4\uff09
  if (key == 'f'|| key == 'F') {  
    if (bool_size == true && bool_Nkey ==false) {
      bool_size = false;
      size(840, 420); 
      frame.setSize(846, 452);
        if(bool_img == true){
          loop();  
        }
    }
    else if (bool_size == false && bool_Nkey ==false) {
      bool_size = true;
      size(1200, 600); 
      frame.setSize(1206, 632);
       if(bool_img == true){
        loop();        
      }
    }
  }
  //H\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406\uff08Hamming\u7a93\u95a2\u6570On/Off\uff09  
  if(key == 'h' && bool_img == false || key == 'H' && bool_img == false){
    if(bool_Hamming == false){
      bool_Hamming = true; 
      fft.window(FFT.HAMMING);
      windowName = "Hamming";
    }
    else if(bool_Hamming == true){
      bool_Hamming = false;
      fft.window(FFT.NONE);
      windowName = "None";
    }
  }  
  //I\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406 \uff08 \u30ad\u30fc\u30dc\u30fc\u30c9\u5272\u5f53\u8aac\u660e\u753b\u50cf\u8868\u793a\u30fb\u975e\u8868\u793a\uff09
   if(key == 'I' || key == 'i'){
     if(bool_img == true){
       bool_img = false;
       loop();
     }
     else if(bool_img == false){
       bool_img = true;
     }
   }
  //T\u30ad\u30fc\u3092\u62bc\u3057\u305f\u3068\u304d\u306e\u51e6\u7406  \uff08 \u4fdd\u5b58\u753b\u50cf\u540d\u5165\u529b\u30c6\u30ad\u30b9\u30c8\u30dc\u30c3\u30af\u30b9\u8868\u793a\uff09
   if(key == 'T' || key == 't'){
     noLoop();
    JPanel panel = new JPanel();
    BoxLayout layout = new BoxLayout(panel, BoxLayout.Y_AXIS);
    panel.setLayout(layout);
    panel.add(new JLabel("\u4fdd\u5b58\u753b\u50cf\u540d\u5165\u529b"));
    JTextField text1 = new JTextField();
    panel.add(text1);

    int r = JOptionPane.showConfirmDialog(
        null,	 // \u30aa\u30fc\u30ca\u30fc\u30a6\u30a3\u30f3\u30c9\u30a6
        panel,	 // \u30e1\u30c3\u30bb\u30fc\u30b8
        "",	 // \u30a6\u30a3\u30f3\u30c9\u30a6\u30bf\u30a4\u30c8\u30eb
        JOptionPane.OK_CANCEL_OPTION,	// \u30aa\u30d7\u30b7\u30e7\u30f3\uff08\u30dc\u30bf\u30f3\u306e\u7a2e\u985e\uff09
        JOptionPane.PLAIN_MESSAGE);	// \u30e1\u30c3\u30bb\u30fc\u30b8\u30bf\u30a4\u30d7\uff08\u30a2\u30a4\u30b3\u30f3\u306e\u7a2e\u985e\uff09
      if( r == 0){
         savefileName = text1.getText(); 
         frameCounter = 1;
         con_frameCounter = 1;
         loop();
      }
      else if( r == 2){
         loop();
      }
   }
}

//******** \u30d7\u30ed\u30b0\u30e9\u30e0\u7d42\u4e86\u6642\u306e\u51e6\u7406 ********//
  public void stop()
{
  minim.stop();
  super.stop();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "FFT_Analyzer" });
  }
}
